diff a/test/hotspot/gtest/gc/shenandoah/test_shenandoahOldHeuristic.cpp b/test/hotspot/gtest/gc/shenandoah/test_shenandoahOldHeuristic.cpp
--- /dev/null
+++ b/test/hotspot/gtest/gc/shenandoah/test_shenandoahOldHeuristic.cpp
@@ -0,0 +1,366 @@
+/*
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+#include "precompiled.hpp"
+#include "unittest.hpp"
+#include "gc/shenandoah/shenandoahHeap.inline.hpp"
+#include "gc/shenandoah/shenandoahHeapRegion.hpp"
+#include "gc/shenandoah/shenandoahGeneration.hpp"
+#include "gc/shenandoah/shenandoahOldGeneration.hpp"
+#include "gc/shenandoah/heuristics/shenandoahOldHeuristics.hpp"
+#include <cstdarg>
+
+// These tests will all be skipped (unless Shenandoah becomes the default
+// collector). To execute these tests, you must enable Shenandoah, which
+// is done with:
+//
+// % make exploded-test TEST="gtest:ShenandoahOld*" CONF=release TEST_OPTS="JAVA_OPTIONS=-XX:+UseShenandoahGC -XX:+UnlockExperimentalVMOptions -XX:ShenandoahGCMode=generational"
+//
+// Please note that these 'unit' tests are really integration tests and rely
+// on the JVM being initialized. These tests manipulate the state of the
+// collector in ways that are not compatible with a normal collection run.
+// If these tests take longer than the minimum time between gc intervals -
+// or, more likely, if you have them paused in a debugger longer than this
+// interval - you can expect trouble. These tests will also not run in a build
+// with asserts enabled because they use APIs that expect to run on a safepoint.
+#ifdef ASSERT
+#define SKIP_IF_NOT_SHENANDOAH()           \
+  tty->print_cr("skipped (debug build)" ); \
+  return;
+#else
+#define SKIP_IF_NOT_SHENANDOAH() \
+    if (!UseShenandoahGC) {      \
+      tty->print_cr("skipped");  \
+      return;                    \
+    }
+#endif
+
+class ShenandoahResetRegions : public ShenandoahHeapRegionClosure {
+ public:
+  virtual void heap_region_do(ShenandoahHeapRegion* region) override {
+    if (!region->is_empty()) {
+      region->make_trash();
+      region->make_empty();
+    }
+    region->set_affiliation(FREE);
+    region->clear_live_data();
+    region->set_top(region->bottom());
+  }
+};
+
+class ShenandoahOldHeuristicTest : public ::testing::Test {
+ protected:
+  ShenandoahHeap* _heap;
+  ShenandoahOldHeuristics* _heuristics;
+  ShenandoahCollectionSet* _collection_set;
+
+  ShenandoahOldHeuristicTest()
+    : _heap(nullptr),
+      _heuristics(nullptr),
+      _collection_set(nullptr) {
+    SKIP_IF_NOT_SHENANDOAH();
+    _heap = ShenandoahHeap::heap();
+    _heuristics = _heap->old_generation()->heuristics();
+    _collection_set = _heap->collection_set();
+    _heap->lock()->lock(false);
+    ShenandoahResetRegions reset;
+    _heap->heap_region_iterate(&reset);
+    _heap->old_generation()->increase_capacity(ShenandoahHeapRegion::region_size_bytes() * 10);
+    _heap->old_generation()->set_evacuation_reserve(ShenandoahHeapRegion::region_size_bytes() * 4);
+    _heuristics->abandon_collection_candidates();
+    _collection_set->clear();
+  }
+
+  ~ShenandoahOldHeuristicTest() override {
+    SKIP_IF_NOT_SHENANDOAH();
+    _heap->lock()->unlock();
+  }
+
+  ShenandoahOldGeneration::State old_generation_state() {
+    return _heap->old_generation()->state();
+  }
+
+  size_t make_garbage(size_t region_idx, size_t garbage_bytes) {
+    ShenandoahHeapRegion* region = _heap->get_region(region_idx);
+    region->set_affiliation(OLD_GENERATION);
+    region->make_regular_allocation(OLD_GENERATION);
+    size_t live_bytes = ShenandoahHeapRegion::region_size_bytes() - garbage_bytes;
+    region->increase_live_data_alloc_words(live_bytes / HeapWordSize);
+    region->set_top(region->end());
+    return region->garbage();
+  }
+
+  size_t create_too_much_garbage_for_one_mixed_evacuation() {
+    size_t garbage_target = _heap->old_generation()->max_capacity() / 2;
+    size_t garbage_total = 0;
+    size_t region_idx = 0;
+    while (garbage_total < garbage_target && region_idx < _heap->num_regions()) {
+      garbage_total += make_garbage_above_collection_threshold(region_idx++);
+    }
+    return garbage_total;
+  }
+
+  void make_pinned(size_t region_idx) {
+    ShenandoahHeapRegion* region = _heap->get_region(region_idx);
+    region->record_pin();
+    region->make_pinned();
+  }
+
+  void make_unpinned(size_t region_idx) {
+    ShenandoahHeapRegion* region = _heap->get_region(region_idx);
+    region->record_unpin();
+    region->make_unpinned();
+  }
+
+  size_t make_garbage_below_collection_threshold(size_t region_idx) {
+    return make_garbage(region_idx, collection_threshold() - 100);
+  }
+
+  size_t make_garbage_above_collection_threshold(size_t region_idx) {
+    return make_garbage(region_idx, collection_threshold() + 100);
+  }
+
+  size_t collection_threshold() const {
+    return ShenandoahHeapRegion::region_size_bytes() * ShenandoahOldGarbageThreshold / 100;
+  }
+
+  bool collection_set_is(size_t r1) { return _collection_set_is(1, r1); }
+  bool collection_set_is(size_t r1, size_t r2) { return _collection_set_is(2, r1, r2); }
+  bool collection_set_is(size_t r1, size_t r2, size_t r3) { return _collection_set_is(3, r1, r2, r3); }
+
+  bool _collection_set_is(size_t count, ...) {
+    va_list args;
+    va_start(args, count);
+    EXPECT_EQ(count, _collection_set->count());
+    bool result = true;
+    for (size_t i = 0; i < count; ++i) {
+      size_t index = va_arg(args, size_t);
+      if (!_collection_set->is_in(index)) {
+        result = false;
+        break;
+      }
+    }
+    va_end(args);
+    return result;
+  }
+};
+
+TEST_VM_F(ShenandoahOldHeuristicTest, select_no_old_regions) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  _heuristics->prepare_for_old_collections();
+  EXPECT_EQ(0U, _heuristics->coalesce_and_fill_candidates_count());
+  EXPECT_EQ(0U, _heuristics->last_old_collection_candidate_index());
+  EXPECT_EQ(0U, _heuristics->unprocessed_old_collection_candidates());
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, select_no_old_region_above_threshold) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  // In this case, we have zero regions to add to the collection set,
+  // but we will have one region that must still be made parseable.
+  make_garbage_below_collection_threshold(10);
+  _heuristics->prepare_for_old_collections();
+  EXPECT_EQ(1U, _heuristics->coalesce_and_fill_candidates_count());
+  EXPECT_EQ(0U, _heuristics->last_old_collection_candidate_index());
+  EXPECT_EQ(0U, _heuristics->unprocessed_old_collection_candidates());
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, select_one_old_region_above_threshold) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  make_garbage_above_collection_threshold(10);
+  _heuristics->prepare_for_old_collections();
+  EXPECT_EQ(1U, _heuristics->coalesce_and_fill_candidates_count());
+  EXPECT_EQ(1U, _heuristics->last_old_collection_candidate_index());
+  EXPECT_EQ(1U, _heuristics->unprocessed_old_collection_candidates());
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, prime_one_old_region) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  size_t garbage = make_garbage_above_collection_threshold(10);
+  _heuristics->prepare_for_old_collections();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_TRUE(collection_set_is(10UL));
+  EXPECT_EQ(garbage, _collection_set->get_old_garbage());
+  EXPECT_EQ(0U, _heuristics->unprocessed_old_collection_candidates());
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, prime_many_old_regions) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  size_t g1 = make_garbage_above_collection_threshold(100);
+  size_t g2 = make_garbage_above_collection_threshold(101);
+  _heuristics->prepare_for_old_collections();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_TRUE(collection_set_is(100UL, 101UL));
+  EXPECT_EQ(g1 + g2, _collection_set->get_old_garbage());
+  EXPECT_EQ(0U, _heuristics->unprocessed_old_collection_candidates());
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, require_multiple_mixed_evacuations) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  size_t garbage = create_too_much_garbage_for_one_mixed_evacuation();
+  _heuristics->prepare_for_old_collections();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_LT(_collection_set->get_old_garbage(), garbage);
+  EXPECT_GT(_heuristics->unprocessed_old_collection_candidates(), 0UL);
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, skip_pinned_regions) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  // Create three old regions with enough garbage to be collected.
+  size_t g1 = make_garbage_above_collection_threshold(0);
+  size_t g2 = make_garbage_above_collection_threshold(1);
+  size_t g3 = make_garbage_above_collection_threshold(2);
+
+  // A region can be pinned when we chose collection set candidates.
+  make_pinned(1);
+  _heuristics->prepare_for_old_collections();
+
+  // We only exclude pinned regions when we actually add regions to the collection set.
+  ASSERT_EQ(3UL, _heuristics->unprocessed_old_collection_candidates());
+
+  // Here the region is still pinned, so it cannot be added to the collection set.
+  _heuristics->prime_collection_set(_collection_set);
+
+  // The two unpinned regions should be added to the collection set and the pinned
+  // region should be retained at the front of the list of candidates as it would be
+  // likely to become unpinned by the next mixed collection cycle.
+  EXPECT_TRUE(collection_set_is(0UL, 2UL));
+  EXPECT_EQ(_collection_set->get_old_garbage(), g1 + g3);
+  EXPECT_EQ(_heuristics->unprocessed_old_collection_candidates(), 1UL);
+
+  // Simulate another mixed collection after making region 1 unpinned. This time,
+  // the now unpinned region should be added to the collection set.
+  make_unpinned(1);
+  _collection_set->clear();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_EQ(_collection_set->get_old_garbage(), g2);
+  EXPECT_TRUE(collection_set_is(1UL));
+  EXPECT_EQ(_heuristics->unprocessed_old_collection_candidates(), 0UL);
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, pinned_region_is_first) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  // Create three old regions with enough garbage to be collected.
+  size_t g1 = make_garbage_above_collection_threshold(0);
+  size_t g2 = make_garbage_above_collection_threshold(1);
+  size_t g3 = make_garbage_above_collection_threshold(2);
+
+  make_pinned(0);
+  _heuristics->prepare_for_old_collections();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_TRUE(collection_set_is(1UL, 2UL));
+  EXPECT_EQ(_heuristics->unprocessed_old_collection_candidates(), 1UL);
+
+  make_unpinned(0);
+  _collection_set->clear();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_TRUE(collection_set_is(0UL));
+  EXPECT_EQ(_heuristics->unprocessed_old_collection_candidates(), 0UL);
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, pinned_region_is_last) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  // Create three old regions with enough garbage to be collected.
+  size_t g1 = make_garbage_above_collection_threshold(0);
+  size_t g2 = make_garbage_above_collection_threshold(1);
+  size_t g3 = make_garbage_above_collection_threshold(2);
+
+  make_pinned(2);
+  _heuristics->prepare_for_old_collections();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_TRUE(collection_set_is(0UL, 1UL));
+  EXPECT_EQ(_collection_set->get_old_garbage(), g1 + g2);
+  EXPECT_EQ(_heuristics->unprocessed_old_collection_candidates(), 1UL);
+
+  make_unpinned(2);
+  _collection_set->clear();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_TRUE(collection_set_is(2UL));
+  EXPECT_EQ(_collection_set->get_old_garbage(), g3);
+  EXPECT_EQ(_heuristics->unprocessed_old_collection_candidates(), 0UL);
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, unpinned_region_is_middle) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  // Create three old regions with enough garbage to be collected.
+  size_t g1 = make_garbage_above_collection_threshold(0);
+  size_t g2 = make_garbage_above_collection_threshold(1);
+  size_t g3 = make_garbage_above_collection_threshold(2);
+
+  make_pinned(0);
+  make_pinned(2);
+  _heuristics->prepare_for_old_collections();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_TRUE(collection_set_is(1UL));
+  EXPECT_EQ(_collection_set->get_old_garbage(), g2);
+  EXPECT_EQ(_heuristics->unprocessed_old_collection_candidates(), 2UL);
+
+  make_unpinned(0);
+  make_unpinned(2);
+  _collection_set->clear();
+  _heuristics->prime_collection_set(_collection_set);
+
+  EXPECT_TRUE(collection_set_is(0UL, 2UL));
+  EXPECT_EQ(_collection_set->get_old_garbage(), g1 + g3);
+  EXPECT_EQ(_heuristics->unprocessed_old_collection_candidates(), 0UL);
+}
+
+TEST_VM_F(ShenandoahOldHeuristicTest, all_candidates_are_pinned) {
+  SKIP_IF_NOT_SHENANDOAH();
+
+  size_t g1 = make_garbage_above_collection_threshold(0);
+  size_t g2 = make_garbage_above_collection_threshold(1);
+  size_t g3 = make_garbage_above_collection_threshold(2);
+
+  make_pinned(0);
+  make_pinned(1);
+  make_pinned(2);
+  _heuristics->prepare_for_old_collections();
+  _heuristics->prime_collection_set(_collection_set);
+
+  // In the case when all candidates are pinned, we want to abandon
+  // this set of mixed collection candidates so that another old collection
+  // can run. This is meant to defend against "bad" JNI code that permanently
+  // leaves an old region in the pinned state.
+  EXPECT_EQ(_collection_set->count(), 0UL);
+  EXPECT_EQ(old_generation_state(), ShenandoahOldGeneration::FILLING);
+}
+#undef SKIP_IF_NOT_SHENANDOAH
diff a/test/hotspot/jtreg/gc/ergonomics/TestDynamicNumberOfGCThreads.java b/test/hotspot/jtreg/gc/ergonomics/TestDynamicNumberOfGCThreads.java
--- a/test/hotspot/jtreg/gc/ergonomics/TestDynamicNumberOfGCThreads.java
+++ b/test/hotspot/jtreg/gc/ergonomics/TestDynamicNumberOfGCThreads.java
@@ -51,17 +51,12 @@
     if (GC.Parallel.isSupported()) {
       noneGCSupported = false;
       testDynamicNumberOfGCThreads("UseParallelGC");
     }
 
-    if (GC.Shenandoah.isSupported()) {
-      noneGCSupported = false;
-      testDynamicNumberOfGCThreads("UseShenandoahGC");
-    }
-
     if (noneGCSupported) {
-      throw new SkippedException("Skipping test because none of G1/Parallel/Shenandoah is supported.");
+      throw new SkippedException("Skipping test because none of G1/Parallel is supported.");
     }
   }
 
   private static void verifyDynamicNumberOfGCThreads(OutputAnalyzer output) {
     output.shouldHaveExitValue(0); // test should run succesfully
diff a/test/hotspot/jtreg/gc/shenandoah/TestAllocIntArrays.java b/test/hotspot/jtreg/gc/shenandoah/TestAllocIntArrays.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestAllocIntArrays.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestAllocIntArrays.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2016, 2018, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -95,10 +96,19 @@
  *      TestAllocIntArrays
  *
  * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
  *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive
  *      TestAllocIntArrays
+ *
+ * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -XX:+ShenandoahVerify
+ *      TestAllocIntArrays
+ *
+ * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      TestAllocIntArrays
  */
 
 /*
  * @test id=static
  * @summary Acceptance tests: collector can withstand allocation
diff a/test/hotspot/jtreg/gc/shenandoah/TestAllocObjectArrays.java b/test/hotspot/jtreg/gc/shenandoah/TestAllocObjectArrays.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestAllocObjectArrays.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestAllocObjectArrays.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2016, 2018, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -97,10 +98,39 @@
  * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
  *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive
  *      TestAllocObjectArrays
  */
 
+/*
+ * @test id=generational
+ * @summary Acceptance tests: collector can withstand allocation
+ * @key randomness
+ * @requires vm.gc.Shenandoah
+ * @library /test/lib
+ *
+ * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -XX:+ShenandoahVerify
+ *      TestAllocObjectArrays
+ *
+ * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      TestAllocObjectArrays
+ *
+ * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -XX:+ShenandoahOOMDuringEvacALot
+ *      -XX:+ShenandoahVerify
+ *      TestAllocObjectArrays
+ *
+ * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -XX:+ShenandoahAllocFailureALot
+ *      -XX:+ShenandoahVerify
+ *      TestAllocObjectArrays
+ */
+
 /*
  * @test id=static
  * @summary Acceptance tests: collector can withstand allocation
  * @key randomness
  * @requires vm.gc.Shenandoah
@@ -132,10 +162,15 @@
  *
  * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
  *      -XX:+UseShenandoahGC
  *      -XX:-UseTLAB -XX:+ShenandoahVerify
  *      TestAllocObjectArrays
+ *
+ * @run main/othervm -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -Xmx1g -Xms1g
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -XX:-UseTLAB -XX:+ShenandoahVerify
+ *      TestAllocObjectArrays
  */
 
 /*
  * @test id=iu-aggressive
  * @summary Acceptance tests: collector can withstand allocation
diff a/test/hotspot/jtreg/gc/shenandoah/TestAllocObjects.java b/test/hotspot/jtreg/gc/shenandoah/TestAllocObjects.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestAllocObjects.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestAllocObjects.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2016, 2018, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -91,10 +92,25 @@
  * @run main/othervm -Xmx1g -Xms1g -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
  *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive
  *      TestAllocObjects
  */
 
+/*
+ * @test id=generational
+ * @summary Acceptance tests: collector can withstand allocation
+ * @requires vm.gc.Shenandoah
+ *
+ * @run main/othervm -Xmx1g -Xms1g -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -XX:+ShenandoahVerify
+ *      TestAllocObjects
+ *
+ * @run main/othervm -Xmx1g -Xms1g -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      TestAllocObjects
+ */
+
 /*
  * @test id=static
  * @summary Acceptance tests: collector can withstand allocation
  * @requires vm.gc.Shenandoah
  *
diff a/test/hotspot/jtreg/gc/shenandoah/TestArrayCopyCheckCast.java b/test/hotspot/jtreg/gc/shenandoah/TestArrayCopyCheckCast.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestArrayCopyCheckCast.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestArrayCopyCheckCast.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2018, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -21,15 +22,22 @@
  * questions.
  *
  */
 
 /*
- * @test
+ * @test id=default
  * @requires vm.gc.Shenandoah
  *
  * @run main/othervm -XX:+UnlockExperimentalVMOptions -XX:+UseShenandoahGC -XX:TieredStopAtLevel=0 -Xmx16m TestArrayCopyCheckCast
  */
+
+/*
+ * @test id=generational
+ * @requires vm.gc.Shenandoah
+ *
+ * @run main/othervm -XX:+UnlockExperimentalVMOptions -XX:+UseShenandoahGC -XX:TieredStopAtLevel=0 -Xmx16m TestArrayCopyCheckCast -XX:ShenandoahGCMode=generational
+ */
 public class TestArrayCopyCheckCast {
 
     static class Foo {}
     static class Bar {}
 
diff a/test/hotspot/jtreg/gc/shenandoah/TestArrayCopyStress.java b/test/hotspot/jtreg/gc/shenandoah/TestArrayCopyStress.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestArrayCopyStress.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestArrayCopyStress.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2018, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -24,17 +25,26 @@
 
 import java.util.Random;
 import jdk.test.lib.Utils;
 
 /*
- * @test
+ * @test id=default
  * @key randomness
  * @requires vm.gc.Shenandoah
  * @library /test/lib
  *
  * @run main/othervm -XX:+UnlockExperimentalVMOptions -XX:+UseShenandoahGC -XX:TieredStopAtLevel=0 -Xmx16m TestArrayCopyStress
  */
+
+/*
+ * @test id=generational
+ * @key randomness
+ * @requires vm.gc.Shenandoah
+ * @library /test/lib
+ *
+ * @run main/othervm -XX:+UnlockExperimentalVMOptions -XX:+UseShenandoahGC -XX:ShenandoahGCMode=generational -XX:TieredStopAtLevel=0 -Xmx16m TestArrayCopyStress
+ */
 public class TestArrayCopyStress {
 
     private static final int ARRAY_SIZE = 1000;
     private static final int ITERATIONS = 10000;
 
diff a/test/hotspot/jtreg/gc/shenandoah/TestDynamicSoftMaxHeapSize.java b/test/hotspot/jtreg/gc/shenandoah/TestDynamicSoftMaxHeapSize.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestDynamicSoftMaxHeapSize.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestDynamicSoftMaxHeapSize.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2020, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -60,10 +61,21 @@
  *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive
  *      -Dtarget=10000
  *      TestDynamicSoftMaxHeapSize
  */
 
+/*
+ * @test id=generational
+ * @requires vm.gc.Shenandoah
+ * @library /test/lib
+ *
+ * @run main/othervm -Xms16m -Xmx512m -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -Dtarget=10000
+ *      TestDynamicSoftMaxHeapSize
+ */
+
 /*
  * @test id=static
  * @requires vm.gc.Shenandoah
  * @library /test/lib
  *
diff a/test/hotspot/jtreg/gc/shenandoah/TestEvilSyncBug.java b/test/hotspot/jtreg/gc/shenandoah/TestEvilSyncBug.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestEvilSyncBug.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestEvilSyncBug.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2016, 2020, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -21,17 +22,27 @@
  * questions.
  *
  */
 
 /*
- * @test
+ * @test id=default
  * @summary Tests for crash/assert when attaching init thread during shutdown
  * @requires vm.gc.Shenandoah
  * @library /test/lib
  * @modules java.base/jdk.internal.misc
  *          java.management
- * @run driver/timeout=480 TestEvilSyncBug
+ * @run driver/timeout=480 TestEvilSyncBug -XX:ShenandoahGCHeuristics=aggressive
+ */
+
+/*
+ * @test id=generational
+ * @summary Tests for crash/assert when attaching init thread during shutdown
+ * @requires vm.gc.Shenandoah
+ * @library /test/lib
+ * @modules java.base/jdk.internal.misc
+ *          java.management
+ * @run driver/timeout=480 TestEvilSyncBug -XX:ShenandoahGCMode=generational
  */
 
 import java.util.*;
 import java.util.concurrent.*;
 import java.util.concurrent.locks.*;
@@ -44,13 +55,14 @@
     private static final int NUM_RUNS = 100;
 
     static Thread[] hooks = new MyHook[10000];
 
     public static void main(String[] args) throws Exception {
-        if (args.length > 0) {
+        if ("test".equals(args[0])) {
             test();
         } else {
+            String options = args[0];
             // Use 1/4 of available processors to avoid over-saturation.
             int numJobs = Math.max(1, Runtime.getRuntime().availableProcessors() / 4);
             ExecutorService pool = Executors.newFixedThreadPool(numJobs);
             Future<?>[] fs = new Future<?>[NUM_RUNS];
 
@@ -59,11 +71,11 @@
                     OutputAnalyzer output = ProcessTools.executeLimitedTestJava("-Xms128m",
                             "-Xmx128m",
                             "-XX:+UnlockExperimentalVMOptions",
                             "-XX:+UnlockDiagnosticVMOptions",
                             "-XX:+UseShenandoahGC",
-                            "-XX:ShenandoahGCHeuristics=aggressive",
+                            options,
                             "TestEvilSyncBug", "test");
                     output.shouldHaveExitValue(0);
                     return null;
                 };
                 fs[c] = pool.submit(task);
diff a/test/hotspot/jtreg/gc/shenandoah/TestGCThreadGroups.java b/test/hotspot/jtreg/gc/shenandoah/TestGCThreadGroups.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestGCThreadGroups.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestGCThreadGroups.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2017, 2020, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -74,10 +75,28 @@
  *      -XX:ConcGCThreads=2 -XX:ParallelGCThreads=4
  *      -Dtarget=100
  *      TestGCThreadGroups
  */
 
+/**
+ * @test id=generational
+ * @summary Test Shenandoah GC uses concurrent/parallel threads correctly
+ * @requires vm.gc.Shenandoah
+ *
+ * @run main/othervm -Xmx16m -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
+ *      -XX:+UseShenandoahGC
+ *      -XX:ConcGCThreads=2 -XX:ParallelGCThreads=4
+ *      -Dtarget=1000 -XX:ShenandoahGCMode=generational
+ *      TestGCThreadGroups
+ *
+ * @run main/othervm -Xmx16m -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions
+ *      -XX:+UseShenandoahGC
+ *      -XX:-UseDynamicNumberOfGCThreads
+ *      -Dtarget=1000 -XX:ShenandoahGCMode=generational
+ *      TestGCThreadGroups
+ */
+
 /**
  * @test id=iu
  * @summary Test Shenandoah GC uses concurrent/parallel threads correctly
  * @requires vm.gc.Shenandoah
  *
diff a/test/hotspot/jtreg/gc/shenandoah/TestHeapUncommit.java b/test/hotspot/jtreg/gc/shenandoah/TestHeapUncommit.java
--- a/test/hotspot/jtreg/gc/shenandoah/TestHeapUncommit.java
+++ b/test/hotspot/jtreg/gc/shenandoah/TestHeapUncommit.java
@@ -1,7 +1,8 @@
 /*
  * Copyright (c) 2017, 2018, Red Hat, Inc. All rights reserved.
+ * Copyright Amazon.com Inc. or its affiliates. All Rights Reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -82,10 +83,32 @@
  *      -XX:+UseShenandoahGC
  *      -XX:-UseTLAB -XX:+ShenandoahVerify
  *      TestHeapUncommit
  */
 
+/*
+ * @test id=generational
+ * @summary Acceptance tests: collector can withstand allocation
+ * @key randomness
+ * @requires vm.gc.Shenandoah
+ * @library /test/lib
+ *
+ * @run main/othervm -Xmx1g -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -XX:+ShenandoahUncommit -XX:ShenandoahUncommitDelay=0
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -XX:+ShenandoahVerify
+ *      TestHeapUncommit
+ *
+ * @run main/othervm -Xmx1g -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -XX:+ShenandoahUncommit -XX:ShenandoahUncommitDelay=0
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      TestHeapUncommit
+ *
+ * @run main/othervm -Xmx1g -XX:+UnlockDiagnosticVMOptions -XX:+UnlockExperimentalVMOptions -XX:+ShenandoahUncommit -XX:ShenandoahUncommitDelay=0
+ *      -XX:+UseShenandoahGC -XX:ShenandoahGCHeuristics=adaptive -XX:ShenandoahGCMode=generational
+ *      -XX:-UseTLAB -XX:+ShenandoahVerify
+ *      TestHeapUncommit
+ */
+
 /*
  * @test id=iu
  * @summary Acceptance tests: collector can withstand allocation
  * @key randomness
  * @requires vm.gc.Shenandoah
